#ifndef _LT_ACTOR_H_
#define _LT_ACTOR_H_

// Standard headers
#include <vector>
#include <string>

// LT headers
#include "LT_quaternion.h"
#include "LT_armature.h"
#include "LT_action.h"
#include "LT_footlock.h"
#include "LT_pose.h"
#include "LT_iksolver.h"

class cActor
{
public:
	cActor();

	void Animate(unsigned int t);
	void ApplyPose(cPose &pose);
	void UpdateArmature(void);
	void DrawArmature(unsigned int mode);
	void SetConstraints(void);

	std::string mName;
	cPose mPose;
	cPose mPose2;
	cArmature mArmature;
	cAction mAction[3];
	unsigned int mNextAction;
	unsigned int mCurrentAction;
	unsigned int mTime;
	unsigned int mBlend;
	unsigned int mWalkCycle;
	cFootLock mLeftFoot;
	cFootLock mRightFoot;
	float mHeading;
};

#endif //_LT_ACTOR_H_
