#ifndef _LT_APP_H_
#define _LT_APP_H_

#include "LT_camera.h"
#include "LT_actor.h"

class cLTApp
{
public:
	void Setup(unsigned int w, unsigned int h);
	void SetupCamera(float xx, float yy, float zz, float dist, int heading, int elevation);
	void LoadActor(const char* fname);
	void Go(void);
	void HandleEvents(void);
	void Update(void);
	void Draw(void);
	static void ExitError(const char* err);

	cCamera mCamera;
	cActor mActor;
	unsigned int mWinWidth;
	unsigned int mWinHeight;
	unsigned int mTime;
	unsigned int mFPS;
	unsigned int mSecondStartTime;
	unsigned int mLastTime;
	unsigned int mCurrentTime;
	unsigned int mDrawMode;
	bool mActive;
	bool mTurnLeft;
	bool mTurnRight;
	bool mWalk;
	bool mPaused;
	bool mLeftMouseButton;
	bool mRightMouseButton;
};

#endif //_LT_APP_H_
