#ifndef _LT_IKSOLVER_H_
#define _LT_IKSOLVER_H_

#include "LT_vector.h"
#include "LT_quaternion.h"
#include "LT_bone.h"
#include "LT_action.h"
#include "LT_armature.h"

#define IK_MAX_TRIES 0
#define IK_THRESHOLD 0.01
#define IK_MAX_ANGLE 60
#define IK_MIN_ANGLE 60

class cIK
{
public:
	void Setup(cArmature &arm);
	void EvaluateAt(unsigned int t, cAction &action);

	cVector3D mTarget;
	cVector3D mEffector;
	// Limit IK chain to only 2 bones
	unsigned int mIndices[2];
	unsigned int mIndex;
	cBone* mIKBones[2];
	cQuaternion mIKpose[2];
	unsigned int mChannels[2];

};

#endif //_LT_IKSOLVER_H_
