#include "LT_sdl.h"
#include "LT_armature.h"

void cArmature::Update(void)
{
	mRootBone->Update();
}

void cArmature::Draw(unsigned int mode)
{
	std::vector<cBone>::iterator itor = mBones.begin();	
	std::vector<cBone>::iterator itend = mBones.end();
	
	float length = 0.0;
	
	while(itor != itend)
	{
		length = (*itor).mLength;
		
		glPushMatrix();
		glMultMatrixf((*itor).mWorldTransform._m);

		switch(mode)
		{
		case 1:
			glBegin(GL_LINES);
			
			//Draw bone - 3D diamond thingy
			glColor3f(1.0, 1.0, 1.0);
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(length*0.1, length*0.1, 0.0);
			
			glVertex3f(length*0.1, length*0.1, 0.0);
			glVertex3f(0.0, length, 0.0);
			
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(-length*0.1, length*0.1, 0.0);
			
			glVertex3f(-length*0.1, length*0.1, 0.0);
			glVertex3f(0.0, length, 0.0);
			
			
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, length*0.1, length*0.1);
			
			glVertex3f(0.0, length*0.1, length*0.1);
			glVertex3f(0.0, length, 0.0);
			
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, length*0.1, -length*0.1);
			
			glVertex3f(0.0, length*0.1, -length*0.1);
			glVertex3f(0.0, length, 0.0);
			
			
			glVertex3f(length*0.1, length*0.1, 0.0);
			glVertex3f(0.0, length*0.1, length*0.1);
			
			glVertex3f(0.0, length*0.1, length*0.1);
			glVertex3f(-length*0.1, length*0.1, 0.0);
			
			glVertex3f(-length*0.1, length*0.1, 0.0);
			glVertex3f(0.0, length*0.1, -length*0.1);
			
			glVertex3f(0.0, length*0.1, -length*0.1);
			glVertex3f(length*0.1, length*0.1, 0.0);
				
			glEnd();
			
			break;
		
		case 2:
			// Draw bone - Lines
			glColor3f(1.0, 1.0, 1.0);

			glBegin(GL_LINES);
				glVertex3f(0.0, 0.0, 0.0);
				glVertex3f(0.0, length, 0.0);
			glEnd();

			break;
		default:
			break;
		}


			//Draw axis
			/*glBegin(GL_LINES);
			glColor3f(1.0, 0.0, 0.0);
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.2, 0.0, 0.0);
			
			glColor3f(0.0, 1.0, 0.0);
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, 0.2, 0.0);
			
			glColor3f(0.0, 0.0, 1.0);
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, 0.0, 0.2);
			glEnd();*/
		
		glPopMatrix();
		
		++itor;	
	}
}
