#include <iostream>

#include "LT_bone.h"
#include "LT_matrix.h"

cBone::cBone()
{
	mParent = NULL;
}

void cBone::Update(void)
{
	cMatrix4D m;
	std::vector<cBone*>::iterator itor = mChildren.begin();
	std::vector<cBone*>::iterator itend = mChildren.end();
	
	m.setFromQuat(mOrientation);
	mTransform.setRotation(mRestTransform*m);
	
	if(mParent != NULL)
	{
		mWorldTransform = mParent->mWorldTransform*mTransform;	
	}
	else
	{
		mWorldTransform = mTransform;	
	}
	
	while(itor != itend)
	{
		(*itor)->Update();
		
		++itor;	
	}
}
