#include "LT_channel.h"
#include "LT_quaternion.h"

void cChannel::EvaluateAt(unsigned int t, cQuaternion &q)
{
	unsigned int key1 = 0;
	unsigned int key2 = 0;
	float dt = 0;
	float param = 0;
	
	for(unsigned int i=0; i<mKeyFrames.size(); ++i)
	{
		if(t >= mKeyFrames[i].mTime) 
		{
			key1 = i;
		}
	}
	
	if(key1 == mKeyFrames.size()-1)
	{
		q = mKeyFrames[key1].mValue; // no need to nlerp same key
	}
	else
	{
		key2 = key1+1;
	}
		
	dt = mKeyFrames[key2].mTime - mKeyFrames[key1].mTime;	
	param = (t - mKeyFrames[key1].mTime) / dt;
	
	q = cQuaternion::nlerp(param, mKeyFrames[key1].mValue, mKeyFrames[key2].mValue);	
}
