#include "LT_footlock.h"
#include "LT_pose.h"
#include <iostream>

void cFootLock::Setup(cBone* b, float xx, float yy, float zz)
{
	mDir.x = xx;
	mDir.y = yy;
	mDir.z = zz;
	mBone = b;
	mLock = false;
	mLastPosition = mBone->mWorldTransform.getTransform();
}

void cFootLock::Evaluate(cBone* root, cPose &pose)
{
	cVector3D tn = mLastPosition - mBone->mWorldTransform.getTransform();
	cVector3D t = tn;

	mDir = root->mChildren[0]->mWorldTransform.getTransform() - root->mWorldTransform.getTransform();
	mDir.normalize();
	tn.normalize();
	if(tn.dot(mDir) > 0.0)
	{
		if(!mLock)
			mLockedPosition = mBone->mWorldTransform.getTransform();
        mLock = true;
		mOffset.x = t.x;
		mOffset.z = t.z;
	}
	else
	{
		mLock = false;
		mOffset.x = 0.0;
		mOffset.z = 0.0;
	}

	mLastPosition = mBone->mWorldTransform.getTransform() + mOffset; //<-- keep the locked position relative to the armature
	pose.mPoseRoot->mTransform.translate(mOffset);
}
