// LT ------------------------------------------------------------------------//
//
// Math
// General Math stuff
//
// Piran Tremethick
// 08/02/06
//----------------------------------------------------------------------------//

// Standard headers
#include <cmath>
#include <ostream>

//LT headers
#include "LT_math.h"

// Some useful constants
const float Math::PI = 3.1415926535;
const float Math::ALMOSTZERO = 0.001;
const float Math::DEGTORAD = PI/180.0f;
const float Math::RADTODEG = 180.0f/PI;

float Math::sqrt(float in)
{
	return std::sqrt(in);
}

float Math::abs(float in)
{
	return std::abs(in);	
}

float Math::sin(float ang)
{
	return std::sin(ang*DEGTORAD);	
};

float Math::cos(float ang)
{
	return std::cos(ang*DEGTORAD);
};

float Math::tan(float ang)
{
	return std::tan(ang*DEGTORAD);
};

float Math::invsin(float ang)
{
	return std::asin(ang)*RADTODEG;
};

float Math::invcos(float ang)
{
	return std::acos(ang)*RADTODEG;
};

float Math::invtan(float ang)
{
	return std::atan(ang)*RADTODEG;
};
	
/*
cAngle::cAngle() { mAng = 0.0; };

std::ostream& operator<< (std::ostream&os, cAngle& in)
{
	os<<"Angle: "<<in.getAngle()<<" rad: "<<in.getAngle(cMath::DEGREES)<<" deg."<<std::endl;
	
	return os;
}*/
