#include <vector>
#include <algorithm>

#include "LT_pose.h"

void cPose::Setup(cArmature &arm)
{
	mPoseBones = arm.mBones;
	mPoseRoot = &(*find(mPoseBones.begin(), mPoseBones.end(), arm.mRootBone->mName));
}

void cPose::Set(cArmature &arm)
{
	std::vector<cBone>::iterator itor = arm.mBones.begin();
	std::vector<cBone>::iterator pitor = mPoseBones.begin();

	while(itor != arm.mBones.end())
	{
		(*pitor).mOrientation = (*itor).mOrientation;
		(*pitor).mTransform = (*itor).mTransform;

		++itor;
		++pitor;
	}
}

void cPose::Update(void)
{
	mPoseRoot->Update();	
}

void cPose::Blend(float t, cPose &p2)
{
	std::vector<cBone>::iterator itor = mPoseBones.begin();
	std::vector<cBone>::iterator pitor = p2.mPoseBones.begin();

	while(itor != mPoseBones.end())
	{
		(*itor).mOrientation = cQuaternion::nlerp(t, (*itor).mOrientation, (*pitor).mOrientation);
		
		++itor;
		++pitor;
	}

}
